function DistributedOptimization
warning off
clear global
options = optimset('Display','off');
global piDefs isRezDefs IterInfo MovFrames

% TODO: Change these
piDefs.N = 3;               % Number of robots
piDefs.L = 11;              % Number of variable pts in each trajectory
piDefs.starts = [-5 0 5];
piDefs.ends =   [-5 0 5];
% % piDefs.N = 4;               % Number of robots
% % piDefs.L = 11;              % Number of variable pts in each trajectory
% % piDefs.starts = [-3 -0.3 0.3 3];
% % piDefs.ends =   [-3  0   0.3 3];

% Initiation - don't change these
piDefs.pairCount = IP(piDefs.N, piDefs.N-1);
for ij=1:piDefs.pairCount
    isRezDefs{ij} = zeros([piDefs.L 1]);
end

% TODO: Change these
isRezDefs{IP(1,2)}([3,9]) = 1;
isRezDefs{IP(2,3)}([6]) = 1;

% % isRezDefs{IP(1,2)}([3]) = 1;
% % isRezDefs{IP(2,3)}([6]) = 1;
% % isRezDefs{IP(3,4)}([10]) = 1;
%isRezDefs{IP(1,2)} = [0 0 1 0 0 0 0 0 1 0 0]';
%isRezDefs{IP(2,3)} = [0 0 0 0 0 1 0 0 0 0 0]';
%isRezDefs{IP(3,4)} = [0 0 1 0 0 0 0 0 1 0 0]';
%isRezDefs{IP(4,5)} = [0 0 0 0 0 1 0 0 0 0 0]';

% Define some global constants
piDefs.L2 = piDefs.L + 2;
for a=1:piDefs.N
    piDefs.Pr{a} = [];
    for b=setdiff(1:piDefs.N,a)
        piDefs.Pr{a}(end+1) = IP(a,b);
    end
end
MovFrames.count = 0;

% -----------------------
% Initiation
IterInfo.k = 0;
for ij=1:piDefs.pairCount
    IterInfo.W(ij) = 0;
end
IterInfo.W = IterInfo.W';
for r=1:piDefs.N
    IterInfo.pi{r} = (0:(piDefs.L-1))';
    IterInfo.pi{r} = piDefs.starts(r) + IterInfo.pi{r}*(piDefs.ends(r)-piDefs.starts(r))/(piDefs.L-1);
end
% Unconstrained planning
for a=1:piDefs.N
    IterInfo.r = a;
    IterInfo.pi{a} = fminunc(@ObjFn,IterInfo.pi{a},options); %[piDefs.starts(a); fminunc(@ObjFn,IterInfo.pi{a}(2:(end-1)),options); piDefs.ends(a)];
end

% Iterations
eps = 0.01; % 0.01
hasConverged = false;
while (IterInfo.k<2000 && ~hasConverged)
    DrawPlots;
    if any(IterInfo.k == [300])
        pause;
    end
    
    r = mod(IterInfo.k, piDefs.N) + 1;
    IterInfo.r = r;
    V = ComputeStepDirection; % Uses IterInfo.r, IterInfo.W and IterInfo.pi
    disp(sprintf('k=%d - r=%d - W=%s - V=%s', IterInfo.k, r, mat2str(IterInfo.W,3), mat2str(V,3)));
    try % For MATLAB compatibility
        fflush(stdout);
    end
    IterInfo.W = IterInfo.W + eps*V;
    IterInfo.pi{r} = fminunc(@ObjFn,IterInfo.pi{r},options); %[piDefs.starts(r); fminunc(@ObjFn,IterInfo.pi{r}(2:(end-1)),options); piDefs.ends(r)];
    IterInfo.k = IterInfo.k + 1;
    
    hasConverged = true;
    for mn=1:piDefs.pairCount
        [m,n] = IP(mn);
        OmgVal = Omg(IterInfo.pi{m}, IterInfo.pi{n}, isRezDefs{mn}, 0, 0);
        if OmgVal > 1e-6
            hasConverged = false;
        end
    end
    %pause;
end

for a=1:piDefs.N
    disp([piDefs.starts(a); IterInfo.pi{a}; piDefs.ends(a)]);
end
try %for OCTAVE compatiility
    movie2avi(MovFrames.F, 'DistributedOptimization_mov3.avi', 'compression','Cinepak');
end

% ===================================================

function res = ObjFn(pi_r_midYs)  % uses IterInfo.r, piDefs.starts, piDefs.ends
global piDefs isRezDefs IterInfo

r = IterInfo.r;
pi_r = [piDefs.starts(r); pi_r_midYs; piDefs.ends(r)];
res = c(pi_r);
for ir=piDefs.Pr{r}
    ii = setdiff(IP(ir), r);
    res = res + IterInfo.W(ir) * Omg(IterInfo.pi{ii}, pi_r_midYs, isRezDefs{ir}, 0, 0);
end

% ===================================================

function DrawPlots
global piDefs IterInfo MovFrames
figure(100);
cla;
hold on;
styles = {'r*-.', 'b+-', 'ko-.', 'b*-', 'r+-'};
linewidth = {0.5, 2.0, 0.5, 0.5, 0.5};
for a=1:piDefs.N
    plot([piDefs.starts(a); IterInfo.pi{a}; piDefs.ends(a)], styles{a}, 'LineWidth', linewidth{a});
end
drawnow;
try %for OCTAVE compatiility
    MovFrames.count = MovFrames.count + 1;
    MovFrames.F(MovFrames.count) = getframe;
end
